=== debian/changelog ===
openmw (0.36.1-1build3) wily; urgency=medium

  * No-change rebuild against libbulletcollision2.83v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 23 Aug 2015 17:28:07 +0000

openmw (0.36.1-1build2) wily; urgency=medium

  * No-change rebuild against libogre-1.9.0v5.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Sat, 15 Aug 2015 23:16:26 +0200

openmw (0.36.1-1build1) wily; urgency=medium

  * No-change rebuild against libbulletcollision2.83

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 05 Aug 2015 06:04:54 +0000

openmw (0.36.1-1) unstable; urgency=low

  * Merge from experimental
  * New release: OpenMW-0.36.1

 -- Bret Curtis <psi29a@gmail.com>  Mon, 01 Jun 2015 08:14:09 +0200

openmw (0.36.0-1) experimental; urgency=low

  * New release: OpenMW-0.36.0
  * Added ESS importor tool for saved games.

 -- Bret Curtis <psi29a@gmail.com>  Tue, 26 May 2015 08:14:09 +0200

openmw (0.35.1-1) experimental; urgency=low

  * New release: OpenMW-0.35.1

 -- Bret Curtis <psi29a@gmail.com>  Fri, 13 Mar 2015 08:14:09 +0200

openmw (0.35.0-1) experimental; urgency=low

  * New release: OpenMW-0.35.0
  * Renamed components to reflect upstream changes.
  * Removed system-font patch, we use symlinks now.

 -- Bret Curtis <psi29a@gmail.com>  Thu, 12 Feb 2015 08:14:09 +0200

openmw (0.34.0-1) experimental; urgency=low

  * New release: OpenMW-0.34.0
  * Updated system-font patch

 -- Bret Curtis <psi29a@gmail.com>  Fri, 19 Dec 2014 08:14:09 +0200

openmw (0.33.0-3) experimental; urgency=low

  * Added ppc64el.patch as a possible compilation fix
  * Updated openmw-cs description

 -- Bret Curtis <psi29a@gmail.com>  Wed, 12 Nov 2014 08:14:09 +0200

openmw (0.33.0-2) experimental; urgency=low

  * Check now on missing files in debian/rules
  * Added missing files
  * Disabled building bsa/esm/nif/mygui tools, they will be packaged later

 -- Bret Curtis <psi29a@gmail.com>  Thu, 30 Oct 2014 08:14:09 +0200

openmw (0.33.0-1) experimental; urgency=low

  * New release: OpenMW-0.33.0
  * Updated system-font patch

 -- Bret Curtis <psi29a@gmail.com>  Tue, 28 Oct 2014 08:14:09 +0200

openmw (0.32.0-1) experimental; urgency=low

  * New release: OpenMW-0.32.0
  * Updated system-font patch
  * Updated build-deps: libavresample-dev and libmygui-dev >= 3.2.1

 -- Bret Curtis <psi29a@gmail.com>  Sat, 13 Sep 2014 08:14:09 +0200

openmw (0.31.0-1) experimental; urgency=low

  [ Bret Curtis ]
  * New release: OpenMW-0.31.0
  * Updated system-font patch

 -- Bret Curtis <psi29a@gmail.com>  Mon, 14 Jul 2014 08:14:09 +0200

openmw (0.30.0-1) experimental; urgency=low

  [ Bret Curtis ]
  * New release: OpenMW-0.30.0
  * Updated system-font patch, removed stdint patch
  * Updated watch file to point to OpenMW organization on github

 -- Bret Curtis <psi29a@gmail.com>  Mon, 19 May 2014 08:14:09 +0200

openmw (0.29.0-1) experimental; urgency=low

  [ Bret Curtis ]
  * New release: OpenMW-0.29.0
  * Out-of-tree build and easy cleanup
  * Updated system-font patch
  * Added use_system_stdint.patch to fix uintptr_t issue

 -- Bret Curtis <psi29a@gmail.com>  Tue, 04 Mar 2014 08:13:09 +0200

openmw (0.28.0-1) experimental; urgency=low

  [ Bret Curtis ]
  * New release: OpenMW-0.28.0

  [ Scott Howard ]
  * Updated debian/watch

 -- Bret Curtis <psi29a@gmail.com>  Tue, 14 Jan 2014 08:13:09 +0200

openmw (0.27.1-1) experimental; urgency=low

  * Bumping for re-tag
  * Rebuild against Ogre 1.9
  * Rebuild against new libmygui (depends on Ogre 1.9)

 -- Bret Curtis <psi29a@gmail.com>  Fri, 03 Jan 2014 08:13:09 +0200

openmw (0.27.0-2) UNRELEASED; urgency=low

  * Updated Vcs-Git and Vcs-Browser

 -- Scott Howard <showard@debian.org>  Fri, 27 Dec 2013 14:01:15 -0500

openmw (0.27.0-1) experimental; urgency=low

  * First release to Debian. (Closes: #727195)

 -- Bret Curtis <psi29a@gmail.com>  Fri, 15 Nov 2013 08:13:09 +0200
